#
# uremove    2.0a  12/19/90
#            2.0d  01/07/91
#            2.07  08/30/91  name change to uremove (was remove)
#
#  Xenix shell script to remove driver
#  (c) 1990-91 Hansco Information Technologies, Inc.
#
tmpdir=/tmp
[ "$1" = "-n" ] && {
   noinput=Y
   shift
}
productname=$1
drivername=$2
version=$3
masterfile=$4
#
getyn() {
        while   read resp
        do      case $resp in
                [yY]*)  return 0                        ;;
                [nN]*)  return 1                        ;;
                *)      echo "Please enter Y or N: \c"  ;;
                esac
        done
}
#
# getcurver     - get the currently installed driver version
#
getcurver() {
        curver=`sed -n "\\;# $productname V; {s;# $productname V;;;p;}" $dvrfile`
}
#
# remove <file> - remove HIT/Ansi additions from <file>
#
remove() {
        remfile=$1
        cp $remfile $remfile.old
        sed -n "\\;# $productname V;,\\;# END $productname; !p" $remfile.old >$remfile
}
#
# purge <file> <name>  - remove specified driver
#       assumes $tmpdir = /tmp directory
#               $version = install driver version
#
purge() {
        dvrfile=$1
        dvrname=$2
        [ -w "$dvrfile" ] || return 4
        getcurver
        installed=UPD
        [ -z "$curver" ] && installed=NO
        [ "$curver" = "$version" ] && installed=YES
        case $installed in
          YES|UPD) [ "$noinput" ] && {
                        remove $dvrfile 
                        echo "$dvrname removed."
                        return 0
                   }
                echo "\nAre you sure you want to remove $dvrname? (y/n) \c"
                getyn && {
                        remove $dvrfile 
                        echo "$dvrname removed." 
                        return 0
                }
                return 2
                ;;
          NO)   echo "$dvrname is not installed."
                return 3
                ;;
        esac
}
#
purge $masterfile "$productname $drivername"
exit $?
